package com.gic.haoban.manage.service.service.out.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.hutool.core.collection.CollectionUtil;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.common.utils.UuidUtil;
import com.gic.haoban.manage.api.dto.AuditDTO;
import com.gic.haoban.manage.api.service.AuditApiService;
import com.gic.haoban.manage.service.dao.mapper.DepartmentMapper;
import com.gic.haoban.manage.service.dao.mapper.StaffMapper;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanAuditMapper;
import com.gic.haoban.manage.service.entity.TabHaobanAudit;
import com.gic.haoban.manage.service.entity.TabHaobanDepartment;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.github.pagehelper.PageHelper;

/**
 * Created by tgs on 2020/2/9.
 */
@Service
public class AuditApiServiceImpl implements AuditApiService{
	@Autowired
	private TabHaobanAuditMapper auditMapper;
	@Autowired
	private DepartmentMapper departmentMapper;
	@Autowired
	private StaffMapper staffMapper;
	@Override
	public Page<AuditDTO> page(Integer auditType, String search,
			String enterpriseId,Integer auditStatus, BasePageInfo pageInfo) {
		List<String> storeIds = new ArrayList<>();
		List<String> staffIds = new ArrayList<>();
		if(StringUtils.isNotEmpty(search)){
			List<TabHaobanDepartment> storeList = departmentMapper.listStoreLikeName(search);
			if(CollectionUtil.isNotEmpty(storeList)){
				storeIds = storeList.stream().map(s->s.getRelatedId()).collect(Collectors.toList());
			}
			List<TabHaobanStaff> staffList = staffMapper.listLikeName(search);
			if(CollectionUtil.isNotEmpty(staffList)){
				staffIds = staffList.stream().map(s->s.getStaffId()).collect(Collectors.toList());
			}
		}
		PageHelper.startPage(pageInfo.getPageNum(), pageInfo.getPageSize());
		com.github.pagehelper.Page<TabHaobanAudit> page = auditMapper.page(auditType, storeIds, staffIds, enterpriseId,auditStatus);
		return PageUtil.changePageHelperToCurrentPage( page,AuditDTO.class);
	}
	@Override
	public void audit(String auditId) {
		TabHaobanAudit tab = new TabHaobanAudit();
		tab.setAuditId(auditId);
		tab.setAuditStatus(1);
		tab.setUpdateTime(new Date());
		auditMapper.updateByPrimaryKeySelective(tab);		
	}
	@Override
	public void refuse(String auditId, String auditReason) {
		TabHaobanAudit tab = new TabHaobanAudit();
		tab.setAuditId(auditId);
		tab.setAuditStatus(0);
		tab.setUpdateTime(new Date());
		tab.setAuditReason(auditReason);
		auditMapper.updateByPrimaryKeySelective(tab);			
	}
	@Override
	public int  save(Integer auditType, String enterpriseId,
			String commitStaffId, String commitStoreId, String changeField,
			String oldValue, String newValue) {
		TabHaobanStaff staff = staffMapper.selectByPrimaryKey(commitStaffId);
		if(staff == null){
			return 0;
		}
		TabHaobanAudit tab = new TabHaobanAudit();	
		tab.setAuditId(UuidUtil.randomUUID());
		tab.setAuditStatus(0);
		tab.setAuditType(auditType);
		tab.setChangeField(changeField);
		tab.setCommitName(null);
		tab.setCommitStaffId(commitStaffId);
		tab.setCommitStaffImg(staff.getHeadImg());
		tab.setCommitStaffName(staff.getStaffName());
		tab.setCommitStoreId(commitStoreId);
		tab.setCommitTime(new Date());
		tab.setCreateTime(new Date());
		tab.setEnterpriseId(enterpriseId);
		tab.setNewValue(newValue);
		tab.setOldValue(oldValue);
		tab.setStatusFlag(1);
		tab.setUpdateTime(new Date());
		return auditMapper.insertSelective(tab);
	}
}
